<?
 function checkday($d) {
    $day_nl=array("zo","ma","di","wo","do","vr","za");
    $day_en=array("su","mo","tu","we","th","fr","sa");
    $day_en_long=array("sun","mon","tue","wed","thu","fri","sat");
    $chd=strtolower($d);
    if (in_array($chd,$day_nl)) return array_search($chd,$day_nl);
    if (in_array($chd,$day_en)) return array_search($chd,$day_en);
    if (in_array($chd,$day_en_long)) return array_search($chd,$day_en_long);
    return false;
 }
 
//Gets 2 timespecs and returns if the current time lies between one of them
 function checkon($from,$to,$button,&$error) {
    $ft=checktime($from,$button,&$error);
    if ($error!="") return false;
    $tt=checktime($to,$button,&$error);
    if ($error!="") return false;
    if ($ft>$tt) return true;
 }

//This fn parses the time spec and returns the last time the spec occured (in
//sec since epoch)
 function checktime($s,$button,&$error) {
    $error="";
    $day_nl=array("ma","di","wo","do","vr","za","zo");
    $day_en=array("mo","tu","we","th","fr","sa","su");
    $day_en_long=array("mon","tue","wed","thu","fri","sat","sun");
    $ok=true;
    $times=explode(" ",$s);
    $now=getdate();
    $mylast=0;
    foreach($times as $t) {
	//Pick out exception words (like always and never)
	if (strtolower($t)=="always") return time();
	if (strtolower($t)=="never") return 0;
	//Parse time
	$tp=explode(":",$t);
	if (count($tp)==1) {
	    $error="No colon in $t";
	    return false;
	}
	if (count($tp)==2) { //alleen h:m
	    array_unshift($tp,"zo-za"); //always matches
	}
	if (strpos($tp[0],"-")===false) { // 1 day only
	    $tp[0]=$tp[0].'-'.$tp[0]; //expand to range of e.g. mo-mo
	}
	//By here, we have tp in the format dd-dd:hh:mm, where hh can be ''
	if (!preg_match('/[0-9]+/',$tp[2]) || $tp[2]>60) {
	    $error="Not a valid minute indication: ".$tp[2];
	    return false;
	}
	if ($tp[1]=="") { //hh=na?
	    $last=mktime($now["hours"],$tp[2],0);
	    if ($last>time()) $last-=60*60; //if overshoot, subtract an hour
	} else { //hh:mm is ok
	    if (!preg_match('/[0-9]+/',$tp[1]) || $tp[1]>59) {
		$error="Not a valid hour: ".$tp[1];
		return false;
	    }
	    $last=mktime($tp[1],$tp[2],0);
	    if ($last>time()) $last-=60*60*24; //if overshoot, subtract 24h
	}
	//hh:mm is ok.
	//Now check its day against the day settings.
	$then=getdate($last);
	$d=explode("-",$tp[0]);
	$fr=checkday($d[0]);
	$to=checkday($d[1]);
	if ($fr===false) {
	    $error=$d[0]."isn't a day! ($t)";
	    return false;
	}
	if ($to===false) {
	    $error=$d[1]."isn't a day! ($t)";
	    return false;
	}
	//Decrease last with 24h until we reach a day that is in range.
	for ($x=0; $x<7; $x++) {
	    if (dayinrange($last,$fr,$to)) break;
	    $last-=24*60*60;
	}
	//make sure we only remember nearest time
	if ($last>$mylast) $mylast=$last;
    }
    //No match found.
    return $mylast;
 }

 //Checks if $time is between the days $fr and $to
 function dayinrange($time,$fr,$to) {
    $d=getdate($time);
    $day=$d["wday"];
    if ($fr<$to) {
	if ($fr>=$day && $to<=$day) return true;
    } else {
	if ($fr<=$day && $to>=$day) return true;
    }
    return false;
 }

 function describe($desc) {
    echo "<i>".htmlentities($desc)."</i><br><br>";
 }
 
 function asktime($ind,$val) {
    echo '<input type="text" name="'.$ind.'" value="'.htmlentities($val).'"><br>';
 }

 function askstring($ind,$val) {
    echo '<input type="text" name="'.$ind.'" value="'.htmlentities($val).'"><br>';
 }

 function gettime($ind,&$err) {
    checktime($_REQUEST[$ind],0,$e);
    $err.=$e;
    return($_REQUEST[$ind]);
 }
 
 function getstring($ind,&$err) {
    return($_REQUEST[$ind]);
 }
 
 function askleds($ind,$val) {
 
 }

?>
