<?
 
 function longtobin($i) {
    $l=chr($i>>24);
    $l.=chr(($i>>16)&0xff);
    $l.=chr(($i>>8)&0xff);
    $l.=chr(($i)&0xff);
    return $l;
 }
 
 function packetstart() {
    echo chr(0x7F);
 }

 function packetend() {
    echo chr(0xFF);
 }
 
 function sendtype4($id, $data) {
    echo chr(4);
    echo longtobin($id);
    $i=0;
    $o="";
    while (isset($data[$i])) {
	echo chr($data[$i++]);
    }
    echo longtobin($i-1);
    echo $o;
 }
 
 function calcchsum($d) {
    $i=5;
    $i+=(strlen($d)>>16)&0xff;
    $i+=(strlen($d)>>8)&0xff;
    $i+=(strlen($d))&0xff;
    $len=strlen($d);
    for ($p=0; $p<$len; $p++) {
	$i=($i+ord($d{$p}))&0xff;
    }
    return($i);
 }
 
 //Disassemble a packet to fetch the ID of it
 function getid($r){
    $p=1;
    $l=0;
    while ($type!=5 && $type!=0xff) {
	$p+=$l;
	$type=ord(substr($r,$p));
	$l=ord(substr($r,$p+1))<<16;
	$l+=ord(substr($r,$p+2))<<8;
	$l+=ord(substr($r,$p+3));
	if ($l==0) {
	    debug("Huh? 0-len packet found? That can't be good.");
	    return 0;
	}
	$l+=4;
	debug("getid(): Found type ".$type." packet");
    }
    if ($type==0xff) {
	debug("getid(): no packet 5 detected.");
	return -1;
    }
    $id=ord(substr($r,$p+9))<<24;
    $id+=ord(substr($r,$p+10))<<16;
    $id+=ord(substr($r,$p+11))<<8;
    $id+=ord(substr($r,$p+12));
    debug("getid(): ID of packet=".dechex($id));
    return($id);
 }
 
 
 function sendtype3($delay) {
    echo chr(3);
    echo chr(0);
    echo chr(0);
    echo chr(1);
    echo chr($delay&0xff);
 }
 
 function getaudio($f){
    $a=file_get_contents($f);
    if (substr($a,0,4)=="Audi") {
	debug("$f = vox-file with header");
	return $a;
    } else {
	debug("$f = headerless vox-file. Adding header.");
	$r="Audi".chr(0x80).chr(0x01).chr(0x01).chr(0x04).chr(0x3E).chr(0x80).chr(0x0).chr(0);
	$r.=longtobin(strlen($a));
	return $r.$a;
    }
 }
 
 function sendtype5($id,$prog,$audiofiles) {
    $d="amber";
    $d.=longtobin($id);
    $d.=chr(1); //transition
    $d.=longtobin(strlen($prog));
    $d.=$prog;
    if (is_array($audiofiles)) {
	$d.=longtobin(count($audiofiles));
	$aud="";
	$aup=array("");
	$currp=count($audiofiles)*4;
	$i=0;
	while (list($k,$file)=each($audiofiles)) {
	    $aud.=getaudio($file);
	    $currp+=strlen($aud);
	    $aup[$i++]=$currp;
	}
	for ($i=0; $i<count($audiofiles); $i++) {
	    $d.=longtobin($aup[$i]);
	    debug("Auptr=".$aup[$i]);
	}
	$d.=$aud;
    } else {
	$d.=longtobin(0);
    }
    $d.=chr(0xff-calcchsum($d.chr(0)."mind"));
    $d.="mind";
    echo longtobin(0x5000000|strlen($d));
    echo $d;
 }

function sendcode($a) {
 $chs=hexdec(substr(md5($a),0,8))&0x7fffffff; 
 if ($chs!=hexdec($_REQUEST["tc"]) || $nomoreviolet || $_REQUEST["st"]=="00") {
    debug(dechex($chs)."!=".$_REQUEST["tc"].", passing through new program.");
    if (substr($a,0,5)=="amber") {
	debug("File is an embedded type 5 frame.");
	echo longtobin(0x5000000|strlen($a));
	$d="amber";
	$d.=longtobin($chs);
	$d.=substr($a,9,strlen($a)-14);
	$d.=chr(0xff-calcchsum($d.chr(0)."mind"));
	$d.="mind";
	echo $d;
	debug("Sending done.");
    } else {
	debug("File seems to be unembedded code.");
	sendtype5($chs,$a,0);
	debug("Sending done.");
    }
 } else {
    debug("Program is the same, not sending update.");
 }

}

?>