//Audio playing routines

#include <signal.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

int midipid=0;
int soxpid=0;

//Signal handler for the SIGCHLD-signal. This is called as soon as the player
//exits, and re-sets the pid var to 0 to indicate nothing is playing.
void exited(int bla) {
    int i;
    i=wait(&i); //anti-zombie
    midipid=0;
    soxpid=0;
}

//Play a midi-file from storage.
void playmidi(int id) {
    char buff[1024];
    if (midipid!=0 || soxpid!=0) return;
    midipid=fork();
    if (midipid==0) {
	sprintf(buff,"storage/%04i",id);
	execlp("./playmidi","./playmidi",buff,NULL);
    }
    signal(SIGCHLD,exited);
}

//Kill the midi-player
void stopmidi() {
    if (midipid!=0) kill(midipid,SIGTERM);
}

//Play a pcm-file from storage.
void playpcm(int id) {
    char buff[1024];
    if (midipid!=0 || soxpid!=0) return;
    soxpid=fork();
    if (soxpid==0) {
	sprintf(buff,"storage/%04i",id);
	execlp("./playvox","./playvox",buff,NULL);
    }
    signal(SIGCHLD,exited);
}

//Kill the pcm-player
void stoppcm() {
    if (soxpid!=0) kill(soxpid,SIGTERM);
}

