//Virtualbaz, main prog

#include "machine.h"
#include "update-mach.h"
#include "main.h"
#include "render.h"
#include "leds.h"
#include "motor.h"
#include <time.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

int state;
long lastupdated;
int download=1;
int trace=0;

//Show debugging info, program trace, ...
void showdebug() {
    long l;
    int i,no;
    printf("\033[H");
    dumpme();
    l=mach_pc-18;
    for (i=0; i<18; i++) {
	printf("%04X: ",l);
	no=mach_vm_decode(l);
	if (l==mach_pc) printf("<----");
	printf("            \n");
	l+=no;
    }
    printf("Run dOwnload=%i Trace=%i\n",download,trace);
}

//Main routine
int main(int argc, char** argv) {
    int i,j;
    update_init();
    if (argc==2) {
	if (loadbinfile(argv[1])!=0) {
	    printf("Error loading file %s.\n",argv[1]);
	    exit(1);
	}
    } else {
	update_do();
    }
    lastupdated=time(NULL);
    mach_vm_reset();
    initscreen();
    state=ST_STEP;
    i=0;
    while(state!=ST_QUIT) {
	if (state==ST_RUNNING || state==ST_STEP) {
	    mach_vm_step();
	    if (state==ST_STEP) state=ST_STOP;

	    i++;
	    if ((i&3)==0) update_leds();
	    if ((i&3)==0) handlemotor();
	    if ((i&7)==0) SetLeds();

    	    usleep(10000);

	    if (state!=ST_RUNNING || trace)  showdebug();

	    
	    //Slow bunny :) 60 secs default update time to help in debugging
	    if (lastupdated+60<time(NULL) && download) {
		lastupdated=time(NULL);
		update_do();
	    }

	} else {
	    usleep(1000);
	}
	state=setrunstate(state);
    }
    return 0;
}
