//Motor handling routines
int motorstate[2];
int motorcounter[2];
int motordir[2];
//Motordir: 0=stop, 1=top->front->down, 2=top->back->down

//Motor handling and sensing is a bit weird in the original hardware: the
//ear axis has 16 sense-points and every time the axis rotates over such a
//point, the MOTORGET-variable gets increased. The absolute position is 
//detected by a 'hole': if you rotate the ears from top to front to down etc,
//there's a 'hole' that's 3 sensor-positions wide just before the ear
//reaches the 'top'-position.

//The physical position of the ears is kept inside the motorstate-variables,
//which go from 0 to 255. The conversion to the MOTORGET-values happens in the
//detectsensor-routine, with the help of the following array detailing the
//'physical' sensor positions.
int senspos[]={13,26,39,52,65,78,91,104,117,130,143,156,169,182,195,208};

int getsensor(int pos) {
    int i;
    for (i=0; i<16; i++) {
	if ((senspos[i]&0xfe)==pos) return 1;
    }
    return 0;
}


//Simulate the motor turning.
void handlemotor() {
    int i;
    for (i=0; i<2; i++) {
	if (motordir[i]==1) {
	    motorstate[i]+=2;
	    motorcounter[i]+=getsensor(motorstate[i]);
	}
	if (motordir[i]==2) {
	    motorstate[i]-=2;
	    motorcounter[i]+=getsensor(motorstate[i]);
	}
	if (motorstate[i]<0) motorstate[i]=255;
	if (motorstate[i]>255) motorstate[i]=0;
	if (motorcounter[i]>255) motorcounter[i]=0;
    }
    if (motordir[0]+motordir[1]!=0) printf("Motors: %i %i, sens %i %i\n",motorstate[0],motorstate[1],motorcounter[0],motorcounter[1]);
}
