//Render a crappy imitation of a bunny, handle keypresses.
#include <unistd.h>
#include "SDL/SDL.h"
#include "main.h"
#include "buttons.h"
#include "leds.h"

SDL_Surface* screen;
SDL_Rect src,dest;

//Inits SDL
void initscreen() {
    if (SDL_Init(SDL_INIT_VIDEO)<0) {
        fprintf(stderr,"Couldn't init SDL!");
        exit(1);
    }
    SDL_WM_SetCaption("VirtualBaz","VirtualBaz");
    screen=SDL_SetVideoMode(150,200,32,SDL_SWSURFACE+SDL_ANYFORMAT);
    if (screen == NULL) {
        fprintf(stderr,"Couldn't create surface! %s\n",SDL_GetError());
        exit(1);
    }
    atexit(SDL_Quit);
}

//Draw one pixel at a surface.
void DrawPixel(SDL_Surface *screen, int x, int y, Uint8 R, Uint8 G, Uint8 B)
{
    Uint32 color = SDL_MapRGB(screen->format, R, G, B);

    switch (screen->format->BytesPerPixel) {
        case 1: { /* Assuming 8-bpp */
            Uint8 *bufp;

            bufp = (Uint8 *)screen->pixels + y*screen->pitch + x;
            *bufp = color;
        }
        break;

        case 2: { /* Probably 15-bpp or 16-bpp */
            Uint16 *bufp;

            bufp = (Uint16 *)screen->pixels + y*screen->pitch/2 + x;
            *bufp = color;
        }
        break;

        case 3: { /* Slow 24-bpp mode, usually not used */
            Uint8 *bufp;

            bufp = (Uint8 *)screen->pixels + y*screen->pitch + x;
            *(bufp+screen->format->Rshift/8) = R;
            *(bufp+screen->format->Gshift/8) = G;
            *(bufp+screen->format->Bshift/8) = B;
        }
        break;

        case 4: { /* Probably 32-bpp */
            Uint32 *bufp;

            bufp = (Uint32 *)screen->pixels + y*screen->pitch/4 + x;
            *bufp = color;
        }
        break;
    }
}


//Draw a rectangle. Could be optimized by incorporating drawpixel-code, but hey...
void DrawRect(SDL_Surface *screen, int x, int y, int x2, int y2, Uint8 R, Uint8 G, Uint8 B) {
    int xx,yy;
    for (xx=x; xx<=x2; xx++) {
	for (yy=y; yy<=y2; yy++) {
	    DrawPixel(screen, xx, yy, R, G, B);
	}
    }
}

//Draw all the leds to the screen and update surface
void SetLeds() {
    DrawRect(screen,65,40,85,60,leds[4][0],leds[4][1],leds[4][2]);
    DrawRect(screen,25,140,45,160,leds[1][0],leds[1][1],leds[1][2]);
    DrawRect(screen,65,140,85,160,leds[2][0],leds[2][1],leds[2][2]);
    DrawRect(screen,105,140,125,160,leds[3][0],leds[3][1],leds[3][2]);
    DrawRect(screen,45,180,145,190,leds[0][0],leds[0][1],leds[0][2]);

    SDL_UpdateRect(screen, 0, 0, 150, 200);    
}

//Handle keys. Yes, this routine is named weirdly.
int setrunstate(int oldstate){
    SDL_Event event;
    int state=oldstate;
    while(SDL_PollEvent(&event)) {
	if (event.type==SDL_QUIT) state=ST_QUIT;
	if (event.type==SDL_KEYDOWN) {
	    if (event.key.keysym.sym == SDLK_ESCAPE) state=ST_QUIT;
	    if (event.key.keysym.sym == SDLK_SPACE) state=ST_STEP;
	    if (event.key.keysym.sym == SDLK_r) state=ST_RUNNING;
	    if (event.key.keysym.sym == SDLK_b) but_mainbutton=1;
	    if (event.key.keysym.sym == SDLK_1) but_volume=1;
	    if (event.key.keysym.sym == SDLK_2) but_volume=2;
	    if (event.key.keysym.sym == SDLK_3) but_volume=3;
	    if (event.key.keysym.sym == SDLK_d) dumpme();
	    if (event.key.keysym.sym == SDLK_o) {
		if (download==1) download=0; else download=1; }
	    if (event.key.keysym.sym == SDLK_t) {
		if (trace==1) trace=0; else trace=1; }
	}
	if (event.type==SDL_KEYUP) {
	    if (event.key.keysym.sym == SDLK_b) but_mainbutton=0;
	}
    }	
    return state;
}
